// ------------------------------------------------
// Test FPGA TANG NANO avec ARDUINO NANO ATmega328P
// ------------------------------------------------
// Injection d'un signal DMD dans le FPGA
// ------------------------------------------------

int images ;
int cycles ;
int lignes ;
int colonnes ;
int nbit ;

byte octet  ;
byte octet1 ;
byte octet2 ;

const int tailleY = 32 ;

#include <avr/pgmspace.h>
#include "Images32.h"

void setup()
{
  
  // Initialisation des ports E/S + LED témoin
  // Port série 500.000 Bps
  
  pinMode(LED_BUILTIN, OUTPUT) ;
  Serial.begin(500000) ;
  
  // Clignotement rapide LED au démarrage

  for (cycles = 1 ; cycles <= 20 ; cycles++ )
  {
      digitalWrite(LED_BUILTIN, HIGH) ; 
      delay(50) ;                     
      digitalWrite(LED_BUILTIN, LOW) ; 
      delay(50) ;
  }

  // Puis attente 2 secondes avant de démarrer
  
  delay(2000) ;                     

}

// Boucle infinie

void loop()
{

  // Boucle pour le nombre d'images avant de faire une pause
  
  for (images = 0 ; images < 20 ; images++ )
  {
    // Boucle sur nombre de cycles de test (temporisation d'affichage des images)
    
    for (cycles = 1 ; cycles <= 20 ; cycles++ )
    {
    
      // C'est parti !
  
      digitalWrite(LED_BUILTIN, HIGH) ;
      
      if (cycles > 1)
      {
        Serial.write(0x08) ; // Refresh
      }
      else
      {
      
        // Traitement pour une trame de 32 lignes x 128 colonnes

        Serial.write(0x80) ; // Début d'image

        for (lignes = 0 ; lignes < tailleY ; lignes++ )
        {            
          for (colonnes = 0 ; colonnes < 128 ; colonnes = colonnes + 2)
          {  
            octet = 0x00 ;

            octet1 = pgm_read_byte_near(&DIM[images][(lignes * 16) + (colonnes / 8)]);
            octet2 = pgm_read_byte_near(&MED[images][(lignes * 16) + (colonnes / 8)]);
          
            nbit   = 7 - colonnes % 8 ;
            bitWrite(octet,0,bitRead(octet2, nbit)) ;
            bitWrite(octet,1,bitRead(octet2, nbit)) ;
            bitWrite(octet,2,bitRead(octet1, nbit)) ;
            bitWrite(octet,4,bitRead(octet2, nbit - 1)) ;
            bitWrite(octet,5,bitRead(octet2, nbit - 1)) ;
            bitWrite(octet,6,bitRead(octet1, nbit - 1)) ;

            Serial.write(octet) ;
          }
        }
      }
    
      // A la fin de chaque groupe de trames, petite temporisation de 2 x 100 ms et extinction de la LED témoin
    
      delay(100) ;
      digitalWrite(LED_BUILTIN, LOW) ; 
      delay(100) ;
    }
    
    // Pause plus longue entre chaque image (sans toutefois exceder la détection "sans signal")
    
    digitalWrite(LED_BUILTIN, LOW) ; 
    delay(700) ;
  }

  // A la fin des images, pause longue (donc indicateur "sans signal")
    
  delay(5000) ;

}
